﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string sSiteCode = "";		    // IPIN 서비스 사이트 코드		(NICE평가정보에서 발급한 사이트코드)
        string sSitePw = "";            // IPIN 서비스 사이트 패스워드	(NICE평가정보에서 발급한 사이트패스워드)


        //┌ sReturnURL 변수에 대한 설명  ──────────────────────────────────────────────────
        //  암호화된 인증결과 데이터를 리턴받을 URL을 프로토콜부터 풀주소로 정의해주세요.

        //  * URL은 반드시 프로토콜부터 입력해야 하며 외부에서 접속이 가능한 주소여야 합니다.
        //  * 당사 샘플페이지 중 ipin_process 페이지가 인증결과 데이터를 리턴받는 페이지입니다.

        //  예 - http://www.test.co.kr/ipin_process.aspX
        //  	 https://www.test.kr:4343/ipin_process.aspX
        //└─────────────────────────────────────────────────────────────────
        string sReturnURL = "http://....../ipin_process.aspx";


        //┌ sCPRequest 변수에 대한 설명  ──────────────────────────────────────────────────
	    //  CP요청번호는 추가적인 보안처리를 위한 변수입니다. 인증 후 인증결과 데이터와 함께 전달됩니다.
	    //  세션에 저장된 값과 비교해 데이터 위변조를 검사하거나, 사용자 특정용으로 이용할 수 있습니다.	
	    //  위변조 검사는 인증에 필수적인 처리는 아니며 보안을 위한 권고 사항입니다.		

	    //  + CP요청번호 설정 방법
	    //  	1. 당사에서 배포된 모듈로 생성
	    //  	2. 귀사에서 임의로 정의(최대 30byte) 
        //└─────────────────────────────────────────────────────────────────
        string sCPRequest   = "";


        // IPIN 서비스 객체 생성
        IPINCLIENTLib.KisinfoClass clsIPINDll = new IPINCLIENTLib.KisinfoClass();


        // CP요청번호 생성
        clsIPINDll.fnRequestSEQ(sSiteCode);
        sCPRequest = clsIPINDll.bstrRandomRequestSEQ;

        //CP 요청번호를 세션에 저장
        //저장된 값은 ipin_result.jsp 페이지에서 데이터 위변조 검사에 이용됩니다.
        Session["CPREQUEST"] = sCPRequest;


        // 암호화 데이터 생성
        int iRtn = clsIPINDll.fnRequest(sSiteCode, sSitePw, sCPRequest, sReturnURL);

        // 암호화 처리결과코드에 따른 처리사항
        if (iRtn == 0)
        {

            // 암호화 데이터 추출
            // 추출된 암호화된 데이터는 당사 팝업 요청시 함께 보내주셔야 합니다.
            string sEncReqData = clsIPINDll.bstrRequestCipherData;

            lbl_Result.Text = "iRtn : " + iRtn + " - 정상 처리되었습니다.<br>";

            Response.Write("<form name=vnoform method='post'>");
            Response.Write(" <input type='hidden' name='enc_data' value='" + sEncReqData + "'/>");
            Response.Write(" <input type='hidden' name='m' value='pubmain'/>");
            Response.Write("</form>");

        }
        else if (iRtn == -9)
        {
            lbl_Result.Text = "iRtn : " + iRtn + " - 입력값 오류 : fnRequest 함수 처리시, 필요한 4개의 파라미터값의 정보를 정확하게 입력해 주시기 바랍니다.";
        }
        else
        {
            lbl_Result.Text = "iRtn : " + iRtn + " - iRtn 값 확인 후, NICE평가정보 전산 담당자에게 문의해 주세요.";
        }
    }
}