﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class ipin_result : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string sSiteCode = "";			// NICE평가정보에서 발급한 IPIN 서비스 사이트코드
        string sSitePw = "";            // NICE평가정보에서 발급한 IPIN 서비스 사이트패스워드


        // ipin_process 페이지에서 전달받은 인증결과 암호화 데이터 취득
        string sResponseData = Request["enc_data"];

        // CP요청번호 추출 
        // ipin_main에서 세션에 저장한 CP요청번호 취득 (세션 이용하지 않는 경우 생략)
        string sCPRequest = (string)Session["CPREQUEST"];


        // IPIN 서비스 객체 생성
        IPINCLIENTLib.KisinfoClass clsIPINDll = new IPINCLIENTLib.KisinfoClass();


        //┌ 복호화 함수 설명  ──────────────────────────────────────────────────────────
	    //  아래 함수 중 귀사에서 원하는 함수로 이용하시기 바랍니다.

	    //  fnResponse 함수: 인증 결과 데이터 복호화
	    //  fnResponseExt 함수: 인증 결과 데이터 복호화 및 CP요청번호 일치여부 확인
        //└───────────────────────────────────────────────────────────────────
        //int iRtn = clsIPINDll.fnResponse(sSiteCode, sSitePw, sResponseData);
        int iRtn = clsIPINDll.fnResponseExt(sSiteCode, sSitePw, sResponseData, sCPRequest);

        // 인증결과코드 확인
        if (iRtn == 1)
        {

            //********************************************************************************************************************************************
            // 인증결과 데이터 추출
            // : 추출된 데이터는 '이름' 외에는 화면에 노출 불가 (hidden 태그 이용 비권장)
            // 
            //   결과 데이터의 통신이 필요한 경우 암호화 데이터(sEncData)로 통신 후 복호화 해주십시오
            //   복호화된 데이터를 통신하는 경우 데이터 유출에 주의해주십시오 (세션처리 권장)     
            //********************************************************************************************************************************************
            
            string sVNumber         = clsIPINDll.bstrVNumber;               // 가상주민번호 (13Byte, 영숫자 조합)
            string sName			= clsIPINDll.bstrName;                  // 이름
            string sAgeCode         = clsIPINDll.bstrAgeCode;               // 연령대 코드 (0~7: 가이드 참조)
            string sGenderCode		= clsIPINDll.bstrGenderCode;            // 성별 코드 (0:여성, 1: 남성)
            string sBirthDate		= clsIPINDll.bstrBirthDate;             // 생년월일 (YYYYMMDD)
            string sNationalInfo	= clsIPINDll.bstrNationalInfo;          // 내/외국인 정보 (0:내국인, 1:외국인)
            string sCPRequestNum	= clsIPINDll.bstrCPRequestNUM;          // CP 요청번호		
            string sDupInfo         = clsIPINDll.bstrDupInfo;               // 중복가입확인값 (64Byte, 개인식별값, DI:Duplicate Info)

            lbl_Result.Text = "가상주민번호 : " + sVNumber + "<br>" +
                              "이름 : " + sName + "<br>" +
                              "중복가입 확인값 (DI) : " + sDupInfo + "<br>" +
                              "연령대 코드 : " + sAgeCode + "<br>" +
                              "성별 코드 : " + sGenderCode + "<br>" +
                              "생년월일 : " + sBirthDate + "<br>" +
                              "내/외국인 정보 : " + sNationalInfo + "<br>" +
                              "CP 요청번호 : " + sCPRequestNum + "<br>" +
                              "------ 복호화 된 정보가 정상인지 확인해 주시기 바랍니다.";

        }
        else if (iRtn == -9)
        {
            lbl_Result.Text = "iRtn : " + iRtn + " - 입력값 오류 : 복호화 처리시, 필요한 파라미터값의 정보를 정확하게 입력해 주시기 바랍니다.";
        }
        else if (iRtn == -12)
        {
            lbl_Result.Text = "iRtn : " + iRtn + " - CP 비밀번호 불일치 : IPIN 서비스 사이트 패스워드를 확인해 주시기 바랍니다.";
        }
        else if (iRtn == -13)
        {
            lbl_Result.Text = "iRtn : " + iRtn + " - CP 요청번호 불일치 : 세션에 넣은 sCPRequest 데이터를 확인해 주시기 바랍니다.";
        }
        else
        {
            lbl_Result.Text = "iRtn : " + iRtn + " - iRtn 값 확인 후, NICE평가정보 전산 담당자에게 문의해주세요.";
        }
    }
}
